#include "LeyOhm.h"
extern PegBitmap gbdbxBitmap;

LeyOhm::LeyOhm(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
init();
}

int LeyOhm::init()
{   
 	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 10;
	const SIGNED width=mClient.Width()-2*margin;

	PegPrompt* Label_V = new PegPrompt(margin, 70, width, "V (V):",0,wStyle);
	PegPrompt* Label_R = new PegPrompt(margin, 90, width, "R (Ohm):",0,wStyle);
	PegPrompt* Label_I = new PegPrompt(margin, 110, width, "I (mA):",0,wStyle);
	PegPrompt* Label_P = new PegPrompt(margin, 130, width, "P (W):",0,wStyle);

    AddR(Label_V);
	AddR(Label_R);
   	AddR(Label_I);
	AddR(Label_P);

    Dada_V = new CPPegString(margin+55, 70, 60, "");
    Dada_R = new CPPegString(margin+55, 90, 60, "");
    Dada_I = new CPPegString(margin+55, 110, 60, "");
    Dada_P = new CPPegString(margin+55, 130, 60, "");

    AddR(Dada_R);
	AddR(Dada_P);
   	AddR(Dada_V);
	AddR(Dada_I);
	
    PegRect rectangle;
    rectangle.Set(MAINFRAME_LEFT, MAINFRAME_TOP+10, MAINFRAME_RIGHT, MAINFRAME_TOP+60);
    PegBitmapButton *imatge = new PegBitmapButton(rectangle,&gbdbxBitmap,0,AF_TRANSPARENT,TYPE_PROMPT,FALSE);
 	AddR(imatge);
 	
    rectangle.Set(50, 160, 120, 180);
 	PegTextButton* boto = new PegTextButton(rectangle, "Calcular", BOTO_1, AF_ENABLED|TJ_CENTER);
	AddR(boto);
	
	return 0;
}

void LeyOhm::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

// decode the triggering signal
SIGNED LeyOhm::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
	    case SIGNAL(BOTO_1,PSF_CLICKED):
        {
            if(dadesOK())
              Calcula();
        }    
        break;
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}


    
WORD LeyOhm::Dialog(char* title, char* message)
{
	//determine size and position for the error message window
	PegRect rr = GetMainFrame()->TopAppRectangle();
	rr.wBottom -= 30;
	rr.wRight -= 10;
	rr.wTop += 10;
	rr.wLeft += 10;
	PegMessageWindow *msg = new PegMessageWindow(rr, title, message, MW_OK, 0,0,0);
	return msg->Execute();
}

bool LeyOhm::dadesOK()
{
	short buits=0;
	
	if((CPString)Dada_P->DataGet()=="")
		buits++;

	if((CPString)Dada_R->DataGet()=="")
		buits++;

	if((CPString)Dada_I->DataGet()=="")
		buits++;
	
	if((CPString)Dada_V->DataGet()=="")
		buits++;
		
	if(buits>2)
	{
		Dialog("Error en datos","Rellenar 2 campos");
		return false;
	}
	return true;
}

void LeyOhm::Calcula()
{
	OBCD aux, aux2, mil;
	Cal_shortto_OBC(1000,&mil);

	// Possibilitats a considerar:
	// R,I => V,P
	// R,V => P,I
	// R,P => I,V
	// I,V => R,P
	// I,P => R,V
	// P,V => R,I
	
	if((CPString)Dada_R->DataGet() != "")
	{
		if((CPString)Dada_I->DataGet() != "")
		{
			aux2 = CPExpression(Dada_I->DataGet());
			Cal_div_OBC(&aux2,&mil);
			aux = CPExpression(Dada_R->DataGet());
						
			// Calcular V
			Cal_mul_OBC(&aux,&aux2); // aux = RI
			Dada_V->DataSet(CPString(aux));
			
			// Calcular P
			Cal_mul_OBC(&aux,&aux2); // aux = VI
			Dada_P->DataSet(CPString(aux)); 
		}
		else
		{
			if((CPString)Dada_V->DataGet()!="")
			{
				aux2 = CPExpression(Dada_R->DataGet());
				aux = CPExpression(Dada_V->DataGet());
				
				// Calcular I
				Cal_div_OBC(&aux,&aux2); // aux = V/R
				Cal_mul_OBC(&aux,&mil);
                Dada_I->DataSet(CPString(aux));
				
				// Calcular P
				aux2 = CPExpression(Dada_V->DataGet());
				Cal_div_OBC(&aux,&mil);
                Cal_mul_OBC(&aux2,&aux);
				Dada_P->DataSet(CPString(aux2)); 
			}
			else
			{
				aux = CPExpression(Dada_R->DataGet());
				aux2 = CPExpression(Dada_P->DataGet());
				
				// Calcular V
				Cal_mul_OBC(&aux2,&aux); // aux2 = R  P
				Cal_sqrt_OBC(&aux2);
				Dada_V->DataSet(CPString(aux2)); 
                	
				// Calcular I				
				Cal_div_OBC(&aux2,&aux); // aux2 = V / R
				Cal_mul_OBC(&aux2,&mil);
				Dada_I->DataSet(CPString(aux2)); 				
			}			
		}
	}
	else
	{
	    if((CPString)Dada_I->DataGet()!="")
	    {
	        aux2 = CPExpression(Dada_I->DataGet());
	        Cal_div_OBC(&aux2,&mil);
	        
	        if((CPString)Dada_V->DataGet()!="")
	        {
	            aux = CPExpression(Dada_V->DataGet());
 				Cal_mul_OBC(&aux,&aux2); // aux2 = V  I
 				Dada_P->DataSet(CPString(aux)); 
				
				aux = CPExpression(Dada_V->DataGet());
				Cal_div_OBC(&aux,&aux2);
				Dada_R->DataSet(CPString(aux)); 
	        }
            else
            {
                aux = CPExpression(Dada_P->DataGet());
                Cal_div_OBC(&aux,&aux2);
                Dada_V->DataSet(CPString(aux)); 
                
                Cal_div_OBC(&aux,&aux2);
                Dada_R->DataSet(CPString(aux)); 
            }        
	    }
        else
        {
            aux = CPExpression(Dada_P->DataGet());
            aux2 = CPExpression(Dada_V->DataGet());
            
            Cal_div_OBC(&aux,&aux2);
	        Cal_mul_OBC(&aux,&mil);
	        Dada_I->DataSet(CPString(aux)); 
	        Cal_div_OBC(&aux,&mil);
	        
	        Cal_div_OBC(&aux2,&aux);
	        Dada_R->DataSet(CPString(aux2)); 
	        
       }        
	}
    Draw();	
}	
            
extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
return "";
}

